model thermostat 
 
  Real x "Average temperature";
  discrete Boolean q(start=false) "Heater state";
  
  parameter Real xon=73 "Turn-on temperature";
  parameter Real xoff=77 "Turn-off temperature";
  
equation 
  q = if not pre(q) and x <= xon then true else if pre(q) and x >= 
    xoff then false else pre(q);
  der(x) = if q then -x + 100 else -x + 50;
end thermostat;
